## visad.cluster
Class ShadowNodeFunctionTypeJ3D

    java.lang.Object
      visad.ShadowType
          visad.java3d.ShadowTypeJ3D
              visad.java3d.ShadowFunctionOrSetTypeJ3D
                  visad.java3d.ShadowFunctionTypeJ3D
                      visad.cluster.ShadowNodeFunctionTypeJ3D

All Implemented Interfaces:
  Serializable

public class ShadowNodeFunctionTypeJ3D
extends ShadowFunctionTypeJ3D

The ShadowNodeFunctionTypeJ3D class shadows the FunctionType class for NodeRendererJ3D, within a DataDisplayLink, under Java3D.

See Also:
  Serialized Form

Field Summary

Fields inherited from class visad.java3d.ShadowFunctionOrSetTypeJ3D
``

Fields inherited from class visad.java3d.ShadowTypeJ3D
``

Fields inherited from class visad.ShadowType
`LEGAL, METERS_PER_DEGREE, NESTED, NOTHING_MAPPED, SIMPLE_ANIMATE_FIELD, SIMPLE_FIELD, SIMPLE_TUPLE`

Constructor Summary
`ShadowNodeFunctionTypeJ3D(MathType t, DataDisplayLink link, ShadowType parent)`

Method Summary
`void` `addSwitch(Object group, Object swit, Control control, Set domain_set, DataRenderer renderer)`
`void` `addToGroup(Object group, Object branch)`
`boolean` `addToGroup(Object group, VisADGeometryArray array, GraphicsModeControl mode, float constant_alpha, float[] constant_color)`
`void` `addToSwitch(Object swit, Object branch)`
`boolean` `doTransform(Object group, Data data, float[] value_array, float[] default_values, DataRenderer renderer)` transform data into a Java3D scene graph; add generated scene graph components as children of group; value_array are inherited valueArray values; default_values are defaults for each display.DisplayRealTypeVector; return true if need post-process
`(package private) static VisADAppearance` `makeAppearance(GraphicsModeControl mode, float constant_alpha, float[] constant_color, VisADGeometryArray array)` construct an VisADAppearance object
`Object` `makeBranch()`
`Object` `makeSwitch()`
`static boolean` `staticAddToGroup(Object group, VisADGeometryArray array, GraphicsModeControl mode, float constant_alpha, float[] constant_color)`
`void` `texture3DToGroup(Object group, VisADGeometryArray arrayX, VisADGeometryArray arrayY, VisADGeometryArray arrayZ, VisADGeometryArray arrayXrev, VisADGeometryArray arrayYrev, VisADGeometryArray arrayZrev, BufferedImage[] images, GraphicsModeControl mode, float constant_alpha, float[] constant_color, int texture_width, int texture_height, int texture_depth, DataRenderer renderer)`

`void`

`textureStackToGroup(Object group, VisADGeometryArray arrayX, VisADGeometryArray arrayY, VisADGeometryArray arrayZ, VisADGeometryArray arrayXrev, VisADGeometryArray arrayYrev, VisADGeometryArray arrayZrev, BufferedImage[] imagesX, BufferedImage[] imagesY, BufferedImage[] imagesZ, GraphicsModeControl mode, float constant_alpha, float[] constant_color, int texture_width, int texture_height, int texture_depth, DataRenderer renderer)`
client must process the VisADSwitch this makes in order to insert in a Java3D scene graph

`void` `textureToGroup(Object group, VisADGeometryArray array, BufferedImage image, GraphicsModeControl mode, float constant_alpha, float[] constant_color, int texture_width, int texture_height)`
`boolean` `wantIndexed()`

Methods inherited from class visad.java3d.ShadowFunctionOrSetTypeJ3D
`adjustZ, getDomain, getRange, getTextMaps, makeGeometrys, makeVisADGeometrys, postProcess, preProcess, recurseRange, setTex3DCoords, setTexCoords, setTexStackCoords, textureDepth, textureHeight, textureWidth`

Methods inherited from class visad.java3d.ShadowTypeJ3D

`addLabelsToGroup, addTextToGroup, allowConstantColorSurfaces, assembleColor, assembleFlow, assembleSelect, assembleShape, assembleSpatial, checkIndices, ensureNotEmpty, ensureNotEmpty, getAdaptedParent, getAdaptedShadowType, getComponents, getData, getDisplay, getDisplayIndices, getLevelOfDifficulty, getMappedDisplayScalar, getMultipleDisplayScalar, getParentText, getParentTextControl, getType, getValueIndices, makeAppearance, makeContour, makeFlow, makePointGeometry, makeStreamline, makeText, mapValues, mapValues, mapValues, setText, staticMakeAppearance, terminalTupleOrScalar, toString`

Methods inherited from class visad.ShadowType

`adjustFlowToEarth, allowCurvedTexture, allowLinearContour, byteToFloat, floatToByte, getAdjustProjectionSeam, getAnyContour, getAnyFlow, getAnyShape, getAnyText, getComponentIndex, getComponentWithRef, getCurvedTexture, getDefaultColorIndex, getIsLinearContour3D, getIsTerminal, getIsTexture3D, getIsTextureMap, getLink, getMultipleSpatialDisplayScalar, getRefToComponent, makePointGeometry, makeSpatialSet, recurseComponent, terminalTupleOrScalar`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ShadowNodeFunctionTypeJ3D

    public ShadowNodeFunctionTypeJ3D(MathType t,
                                     DataDisplayLink link,
                                     ShadowType parent)
                              throws VisADException,
                                     RemoteException

Method Detail

### doTransform

    public boolean doTransform(Object group,
                               Data data,
                               float[] value_array,
                               float[] default_values,
                               DataRenderer renderer)
                        throws VisADException,
                               RemoteException

  Description copied from class: `ShadowFunctionOrSetTypeJ3D`
  transform data into a Java3D scene graph; add generated scene graph components as children of group; value_array are inherited valueArray values; default_values are defaults for each display.DisplayRealTypeVector; return true if need post-process

  Overrides:
    `doTransform` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`
    `RemoteException`

### textureToGroup

    public void textureToGroup(Object group,
                               VisADGeometryArray array,
                               BufferedImage image,
                               GraphicsModeControl mode,
                               float constant_alpha,
                               float[] constant_color,
                               int texture_width,
                               int texture_height)
                        throws VisADException

  Overrides:
    `textureToGroup` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`

### texture3DToGroup

    public void texture3DToGroup(Object group,
                                 VisADGeometryArray arrayX,
                                 VisADGeometryArray arrayY,
                                 VisADGeometryArray arrayZ,
                                 VisADGeometryArray arrayXrev,
                                 VisADGeometryArray arrayYrev,
                                 VisADGeometryArray arrayZrev,
                                 BufferedImage[] images,
                                 GraphicsModeControl mode,
                                 float constant_alpha,
                                 float[] constant_color,
                                 int texture_width,
                                 int texture_height,
                                 int texture_depth,
                                 DataRenderer renderer)
                          throws VisADException

  Overrides:
    `texture3DToGroup` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`

### textureStackToGroup

    public void textureStackToGroup(Object group,
                                    VisADGeometryArray arrayX,
                                    VisADGeometryArray arrayY,
                                    VisADGeometryArray arrayZ,
                                    VisADGeometryArray arrayXrev,
                                    VisADGeometryArray arrayYrev,
                                    VisADGeometryArray arrayZrev,
                                    BufferedImage[] imagesX,
                                    BufferedImage[] imagesY,
                                    BufferedImage[] imagesZ,
                                    GraphicsModeControl mode,
                                    float constant_alpha,
                                    float[] constant_color,
                                    int texture_width,
                                    int texture_height,
                                    int texture_depth,
                                    DataRenderer renderer)
                             throws VisADException

  client must process the VisADSwitch this makes in order to insert in a Java3D scene graph

  Overrides:
    `textureStackToGroup` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`

### makeSwitch

    public Object makeSwitch()

  Overrides:
    `makeSwitch` in class `ShadowFunctionOrSetTypeJ3D`

### makeBranch

    public Object makeBranch()

  Overrides:
    `makeBranch` in class `ShadowFunctionOrSetTypeJ3D`

### addToGroup

    public void addToGroup(Object group,
                           Object branch)
                    throws VisADException

  Overrides:
    `addToGroup` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`

### addToSwitch

    public void addToSwitch(Object swit,
                            Object branch)
                     throws VisADException

  Overrides:
    `addToSwitch` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`

### addSwitch

    public void addSwitch(Object group,
                          Object swit,
                          Control control,
                          Set domain_set,
                          DataRenderer renderer)
                   throws VisADException

  Overrides:
    `addSwitch` in class `ShadowFunctionOrSetTypeJ3D`
  Throws:
    `VisADException`

### wantIndexed

    public boolean wantIndexed()

  Overrides:
    `wantIndexed` in class `ShadowFunctionOrSetTypeJ3D`

### addToGroup

    public boolean addToGroup(Object group,
                              VisADGeometryArray array,
                              GraphicsModeControl mode,
                              float constant_alpha,
                              float[] constant_color)
                       throws VisADException

  Overrides:
    `addToGroup` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`

### staticAddToGroup

    public static boolean staticAddToGroup(Object group,
                                           VisADGeometryArray array,
                                           GraphicsModeControl mode,
                                           float constant_alpha,
                                           float[] constant_color)
                                    throws VisADException

  Throws:
    `VisADException`

### makeAppearance

    static VisADAppearance makeAppearance(GraphicsModeControl mode,
                                          float constant_alpha,
                                          float[] constant_color,
                                          VisADGeometryArray array)

  construct an VisADAppearance object